package freedom.server.transaction;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import freedom.server.DBConnector;
import freedom.server.model.Day;

public class DayManager {

	public List getDayList(int eventID) throws Exception {
		List dayList = new ArrayList();

		String sql = "SELECT * FROM day where event_id = '" + eventID
				+ "' ORDER BY date;";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Day day = null;
			TermManager manager = new TermManager();
			List termList = manager.getTermList(rs.getInt("id"));
			day = new Day(rs.getInt("id"), rs.getDate("date"), rs
					.getBoolean("isdefined"), rs.getInt("event_id"), termList);
			dayList.add(day);
		}
		con.finish();

		return dayList;
	}

	public List getDayList(int eventID, int[] vipID) throws Exception {
		List dayList = new ArrayList();

		String sql = "SELECT * FROM day where event_id = '" + eventID + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Day day = null;
			TermManager manager = new TermManager();
			List termList = manager.getTermList(rs.getInt("id"), vipID);
			day = new Day(rs.getInt("id"), rs.getDate("date"), rs
					.getBoolean("isdefined"), rs.getInt("event_id"), termList);
			dayList.add(day);
		}
		con.finish();

		return dayList;
	}

	public List getDefinedDayList(int eventID, String date) throws Exception {
		List dayList = new ArrayList();

		String sql = "SELECT * FROM day where event_id = '" + eventID
				+ "' AND date = '" + date + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Day day = null;
			TermManager manager = new TermManager();
			List termList = manager.getTermList(rs.getInt("id"));
			day = new Day(rs.getInt("id"), rs.getDate("date"), rs
					.getBoolean("isdefined"), rs.getInt("event_id"), termList);
			dayList.add(day);
		}
		con.finish();

		return dayList;
	}

	public List getDefinedDayList(int eventID) throws Exception {
		List dayList = new ArrayList();

		String sql = "SELECT * FROM day where event_id = '" + eventID
				+ "' AND isdefined = 'true';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Day day = null;
			TermManager manager = new TermManager();
			List termList = manager.getTermList(rs.getInt("id"));
			day = new Day(rs.getInt("id"), rs.getDate("date"), rs
					.getBoolean("isdefined"), rs.getInt("event_id"), termList);
			dayList.add(day);
		}
		con.finish();

		return dayList;
	}

	public void registerDefinedSchedule(List definedDayList) throws Exception {
		DBConnector con = DBConnector.getConnector(true);
		con.executeUpdate("UPDATE day SET isdefined = 'false';");

		for (Iterator ite = definedDayList.iterator(); ite.hasNext();) {
			Day day = (Day) ite.next();

			String sql = "UPDATE day SET isdefined = 'true' WHERE id = '"
					+ day.getID() + "';";
			con.executeUpdate(sql);
		}
		con.finish();
	}

	/**
	 * o^
	 * 
	 * @param day
	 * @throws Exception
	 */
	public List register(int eventId, List dateList) throws Exception {
		List dayIdList = new ArrayList();
		DBConnector con = DBConnector.getConnector(true);

		for (int i = 0; i < dateList.size(); i++) {
			// o^sID擾
			String selectSql = "SELECT nextval('day_id_seq') AS nextId";
			ResultSet rs = con.executeQuery(selectSql);
			rs.next();
			int dayId = rs.getInt("nextId");
			dayIdList.add(new Integer(dayId));

			// o^
			String insertSql = "INSERT INTO day(id, event_id, date) VALUES ('"
					+ dayId + "','" + eventId + "','" + dateList.get(i) + "')";
			System.out.println(dateList.get(i));
			con.executeUpdate(insertSql);
		}

		con.finish();

		return dayIdList;
	}

	/**
	 * ̌폜
	 * 
	 * @param eventID
	 * @throws Exception
	 */
	public void deleteDays(int eventID, List deleteDateList) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		System.out.println("Ă[");

		for (int i = 0; i < deleteDateList.size(); i++) {
			String sql = "DELETE FROM day WHERE event_id = '" + eventID
					+ "' AND date = '" + deleteDateList.get(i) + "'";
			System.out.println(sql);
			con.executeUpdate(sql);
		}
		con.finish();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	}
}
