package freedom.server.transaction;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;

import freedom.server.DBConnector;
import freedom.server.model.Day;
import freedom.server.model.Participant;
import freedom.server.model.Schedule;
import freedom.server.model.Term;

public class ScheduleManager {

	public void registSchedule(String mailAddress, int eventID)
			throws Exception {
		DBConnector con = DBConnector.getConnector(true);
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();
		ParticipantManager participantManager = new ParticipantManager();

		Participant participant = participantManager.getParticipant(
				mailAddress, eventID);

		List dayList = dayManager.getDayList(eventID);
		for (Iterator ite = dayList.iterator(); ite.hasNext();) {
			Day day = (Day) ite.next();
			List termList = termManager.getTermList(day.getID());
			for (Iterator ite2 = termList.iterator(); ite2.hasNext();) {
				Term term = (Term) ite2.next();
				// ܂XPW[o^ĂȂo^
				if (getSchedule(participant.getID(), term.getID()) == null) {
					String sql = "INSERT INTO schedule(term_id, user_id) VALUES ('"
							+ term.getID() + "','" + participant.getID() + "')";
					con.executeUpdate(sql);
				}
			}
		}
		con.finish();
	}

	/**
	 * \o^
	 */
	public void updateSchedule(int userID, int eventID, String[] conviniences)
			throws Exception {
		DBConnector con = DBConnector.getConnector(true);
		// DayManager dayManager = new DayManager();
		// TermManager termManager = new TermManager();
		//
		// int i = 0;
		// List dayList = dayManager.getDayList(eventID);
		// for (Iterator ite = dayList.iterator(); ite.hasNext();) {
		// Day day = (Day) ite.next();
		// List termList = termManager.getTermList(day.getID());
		// for (Iterator ite2 = termList.iterator(); ite2.hasNext();) {
		// Term term = (Term) ite2.next();
		for (int i = 0; i < conviniences.length; i++) {
			String sql = "UPDATE schedule SET convinience = "
					+ conviniences[i].split(",")[1] + " WHERE term_id = '"
					+ conviniences[i].split(",")[0] + "' AND user_id = '"
					+ userID + "';";
			con.executeUpdate(sql);
		}
		// }
		// i++;
		// }
		con.finish();
	}

	public Schedule getSchedule(int userID, int termID) throws Exception {
		Schedule schedule = null;

		String sql = "SELECT * FROM schedule where term_id = '" + termID
				+ "' AND user_id = '" + userID + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);
		if (rs.next()) {
			schedule = new Schedule(rs.getInt("convinience"), rs
					.getInt("user_id"), rs.getInt("term_id"));
		}
		con.finish();

		return schedule;
	}

	public List getScheduleList(int eventID) throws Exception {
		List scheduleList = new ArrayList();

		List participantList = new ParticipantManager()
				.getParticipantList(eventID);

		for (Iterator ite = participantList.iterator(); ite.hasNext();) {
			Participant participant = (Participant) ite.next();
			participant.getID();

			String sql = "SELECT * FROM schedule where user_id = '"
					+ participant.getID() + "';";
			DBConnector con = DBConnector.getConnector();
			ResultSet rs = con.executeQuery(sql);

			while (rs.next()) {
				Schedule schedule = null;
				schedule = new Schedule(rs.getInt("convinience"), rs
						.getInt("user_id"), rs.getInt("term_id"));
				scheduleList.add(schedule);
			}
			con.finish();
		}
		return scheduleList;
	}

	public List getScheduleList(int eventID, String mailAddress)
			throws Exception {
		List scheduleList = new ArrayList();

		Participant participant = new ParticipantManager().getParticipant(
				mailAddress, eventID);
		String sql = "SELECT * FROM schedule where user_id = '"
				+ participant.getID() + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Schedule schedule = new Schedule(rs.getInt("convinience"), rs
					.getInt("user_id"), rs.getInt("term_id"));
			scheduleList.add(schedule);
		}
		con.finish();
		return scheduleList;
	}

	public List getTermScheduleList(int termID) throws Exception {
		List scheduleList = new ArrayList();

		String sql = "SELECT * FROM schedule where term_id = '" + termID + "';";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Schedule schedule = null;
			schedule = new Schedule(rs.getInt("convinience"), rs
					.getInt("user_id"), rs.getInt("term_id"));
			scheduleList.add(schedule);
		}
		con.finish();
		return scheduleList;
	}

	public List getCalendarList(List dayList) {
		List calendarList = new ArrayList();
		Calendar firstDayCalendar = getFirstDayCalendar(dayList);
		Calendar lastDayCalendar = getLastDayCalendar(dayList);
		Calendar current = firstDayCalendar;
		while (true) {
			int year;
			int month;
			int day;
			if (!firstDayCalendar.equals(lastDayCalendar)) {
				year = current.get(Calendar.YEAR);
				month = current.get(Calendar.MONTH);
				day = current.get(Calendar.DATE);
				calendarList.add(new GregorianCalendar(year, month, day));
				current.set(year, month, day + 1);
				continue;
			}
			year = current.get(Calendar.YEAR);
			month = current.get(Calendar.MONTH);
			day = current.get(Calendar.DATE);
			calendarList.add(new GregorianCalendar(year, month, day));
			current.set(year, month, day + 1);
			break;
		}
		return calendarList;
	}

	private Calendar getFirstDayCalendar(List dayList) {
		Day firstDay = (Day) dayList.get(0);
		Date date = firstDay.getDate();
		String dateString = date.toString();
		String[] splitedDateString = dateString.split("-");
		int year = Integer.parseInt(splitedDateString[0]);
		int month = Integer.parseInt(splitedDateString[1]);
		int day = Integer.parseInt(splitedDateString[2]);

		Calendar firstDayCalendar = new GregorianCalendar(year, month - 1, day);
		firstDayCalendar.set(year, month - 1, (firstDayCalendar
				.get(Calendar.DATE)
				- firstDayCalendar.get(Calendar.DAY_OF_WEEK) + 1));
		return firstDayCalendar;
	}

	private Calendar getLastDayCalendar(List dayList) {
		Day lastDay = (Day) dayList.get(dayList.size() - 1);
		Date date = lastDay.getDate();
		String dateString = date.toString();
		String[] splitedDateString = dateString.split("-");
		int year = Integer.parseInt(splitedDateString[0]);
		int month = Integer.parseInt(splitedDateString[1]);
		int day = Integer.parseInt(splitedDateString[2]);

		Calendar lastDayCalendar = new GregorianCalendar(year, month - 1, day);
		int lastDayWeek = Calendar.SATURDAY
				- lastDayCalendar.get(Calendar.DAY_OF_WEEK);
		lastDayCalendar.set(year, month - 1, (lastDayCalendar
				.get(Calendar.DATE) + lastDayWeek));
		return lastDayCalendar;
	}
}
