package freedom.server.transaction;

import java.sql.ResultSet;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import freedom.server.DBConnector;
import freedom.server.model.Day;
import freedom.server.model.Schedule;
import freedom.server.model.Term;

public class TermManager {

	public List getTermList(int dayID) throws Exception {
		List termList = new ArrayList();

		String sql = "SELECT * FROM term where day_id = '" + dayID
				+ "' ORDER BY start_hour, start_minute;";
		DBConnector con = DBConnector.getConnector();
		ResultSet rs = con.executeQuery(sql);

		while (rs.next()) {
			Term term = null;
			term = new Term(rs.getInt("id"), rs.getInt("start_hour"), rs
					.getInt("start_minute"), rs.getInt("end_hour"), rs
					.getInt("end_minute"), rs.getInt("day_id"));
			termList.add(term);
		}
		con.finish();

		return termList;
	}

	public List getTermList(int eventID, int[] vipID) throws Exception {
		List termList = new ArrayList();
		DayManager dayManager = new DayManager();
		List dayList = dayManager.getDayList(eventID);

		DBConnector con = DBConnector.getConnector();
		for (Iterator ite = dayList.iterator(); ite.hasNext();) {
			Day day = (Day) ite.next();
			String sql = "SELECT * FROM term where day_id = '" + day.getID()
					+ "';";
			ResultSet rs = con.executeQuery(sql);

			while (rs.next()) {
				Term term = null;
				term = new Term(rs.getInt("id"), rs.getInt("start_hour"), rs
						.getInt("start_minute"), rs.getInt("end_hour"), rs
						.getInt("end_minute"), rs.getInt("day_id"));
				List scheduleList = new ScheduleManager()
						.getTermScheduleList(term.getID());
				int participantNumber = 0;
				int vipNumver = 0;
				for (Iterator ite2 = scheduleList.iterator(); ite2.hasNext();) {
					Schedule schedule = (Schedule) ite2.next();
					if (schedule.getConvinience() == Schedule.GOOD) {
						if (isVip(schedule, vipID)) {
							vipNumver++;
						} else {
							participantNumber++;
						}
					}
				}
				term.setParticipantNumber(participantNumber);
				term.setVipNumber(vipNumver);
				termList.add(term);
			}
		}
		con.finish();

		Collections.sort(termList, new ParticipantComparator());
		Collections.sort(termList, new VipComparator());
		List sortedTermList = new ArrayList();
		int priority = 1;
		for (int i = 0; i < termList.size(); i++) {
			Term term = (Term) termList.get(i);
			Term nextTerm;
			if (i < termList.size() - 1) {
				nextTerm = (Term) termList.get(i + 1);
				term.setPriority(priority);
				sortedTermList.add(term);
				if (priority <= 4
						&& (term.getParticipantNumber() != nextTerm
								.getParticipantNumber() || term.getVipNumber() != nextTerm
								.getVipNumber())) {
					priority++;
				}
			} else {
				term.setPriority(priority);
				sortedTermList.add(term);
			}
		}

		return sortedTermList;
	}

	public Term getDefinedTerm(List dayList) throws Exception {
		Term term = null;
		if (dayList.size() > 0) {
			Day day = (Day) dayList.get(0);
			String sql = "SELECT * FROM term where day_id = '" + day.getID()
					+ "' AND isdefined = 'true';";
			DBConnector con = DBConnector.getConnector();
			ResultSet rs = con.executeQuery(sql);

			rs.next();
			term = term = new Term(rs.getInt("id"), rs.getInt("start_hour"), rs
					.getInt("start_minute"), rs.getInt("end_hour"), rs
					.getInt("end_minute"), rs.getInt("day_id"));
			con.finish();
		}

		return term;
	}

	public void registDefine(List dayList, int beginningHour,
			int beginningMinute, int eventID) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		for (Iterator ite = dayList.iterator(); ite.hasNext();) {
			Day day = (Day) ite.next();
			String sql = "UPDATE term SET isdefined = 'true' WHERE day_id = '"
					+ day.getID() + "' AND start_hour = '" + beginningHour
					+ "' AND start_minute = '" + beginningMinute + "';";
			con.executeUpdate(sql);
		}
		con.finish();
	}

	private boolean isVip(Schedule schedule, int[] vipID) {
		for (int i = 0; i < vipID.length; i++) {
			System.out.println("vipID:" + vipID[i]);
			if (schedule.getUserID() == vipID[i]) {
				return true;
			}
		}
		return false;
	}

	/**
	 * ⎞Ԃo^
	 */
	public void register(List termList, List dayIdList) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		for (int k = 0; k < dayIdList.size(); k++) {
			for (int i = 0; i < termList.size(); i++) {
				Term term = (Term) termList.get(i);
				String sql = "INSERT INTO term(start_hour, start_minute, end_hour, end_minute, day_id) VALUES ('"
						+ term.getStartHour()
						+ "','"
						+ term.getStartMinute()
						+ "','"
						+ term.getEndHour()
						+ "','"
						+ term.getEndMinute() + "','" + dayIdList.get(k) + "')";
				con.executeUpdate(sql);
			}
		}

		con.finish();
	}

	/**
	 * Cxg폜
	 * 
	 * @param eventID
	 * @throws Exception
	 */
	public void delete(List termList, List dayIdList) throws Exception {
		DBConnector con = DBConnector.getConnector(true);

		for (int j = 0; j < dayIdList.size(); j++) {
			for (int i = 0; i < termList.size(); i++) {
				Term term = (Term) termList.get(i);
				String sql = "DELETE FROM term WHERE day_id = '"
						+ dayIdList.get(j) + "' AND start_hour = '"
						+ term.getStartHour() + "' AND start_minute = '"
						+ term.getStartMinute() + "'";
				con.executeUpdate(sql);
			}
		}
		con.finish();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
	}
}
