package freedom.struts.event.action;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;

public class ChangeEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm daf = (DynaActionForm) actionForm;
		Event event = new Event();
		Day day = new Day();
		EventManager eventManager = new EventManager();
		DayManager dayManager = new DayManager();
		List dayList = new ArrayList();
		List termList = new ArrayList();
		Calendar cal = Calendar.getInstance();

		int eventID = Integer.parseInt(request.getParameter("eventID"));
		event = eventManager.getEventById(eventID);

		dayList = dayManager.getDayList(eventID);
		String dayArray[] = new String[dayList.size()];

		for (int i = 0; i < dayList.size(); i++) {
			day = (Day) dayList.get(i);
			dayArray[i] = day.getDate().toString();
		}

		Date deadline = event.getReplyDeadline();
		cal.setTime(deadline);

		day = (Day) dayList.get(0);
		termList = day.getTerm();

		Term firstTerm, lastTerm;
		firstTerm = (Term) termList.get(0);
		lastTerm = (Term) termList.get(termList.size() - 1);

		String addresses = event.getParticipantAddress();

		// StringBuffer participantAddress = new StringBuffer(addresses[0]);
		// for (int i = 1; i < addresses.length; i++) {
		// participantAddress.append("\n");
		// participantAddress.append(addresses[i]);
		// }

		daf.set("eventID", new Integer(eventID));
		daf.set("name", event.getName());
		daf.set("hostName", event.getHostName());
		daf.set("hostAddress", event.getHostAddress());
		daf.set("participantAddress", addresses);
		daf.set("outline", event.getOutline());
		daf.set("monthLimit", new Integer(cal.get(Calendar.MONTH) + 1));
		daf.set("dayLimit", new Integer(cal.get(Calendar.DATE)));
		daf.set("requiredDays", new Integer(event.getRequiredDays()));
		daf.set("requiredHours", new Integer(event.getRequiredHours()));
		daf.set("requiredMinutes", new Integer(event.getRequiredMinutes()));
		daf.set("candidateDay", dayArray);
		daf
				.set("candidateBeginningHour", new Integer(firstTerm
						.getStartHour()));
		daf.set("candidateBeginningMinute", new Integer(firstTerm
				.getStartMinute()));
		daf.set("candidateEndingHour", new Integer(lastTerm.getEndHour()));
		daf.set("candidateEndingMinute", new Integer(lastTerm.getEndMinute()));

		return mapping.findForward("success");
	}
}
