package freedom.struts.event.action;

import java.lang.reflect.Array;
import java.sql.Date;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Timer;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class RegistEventAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {

		DynaActionForm daf = (DynaActionForm) actionForm;
		EventManager eventManager = new EventManager();
		DayManager dayManager = new DayManager();
		ScheduleManager scheduleManager = new ScheduleManager();
		TermManager termManager = new TermManager();
		ParticipantManager participantManager = new ParticipantManager();
		Calendar cal = Calendar.getInstance();

		// 񓚊Date^ɕϊ
		Date limit = Date.valueOf(String.valueOf(cal.get(Calendar.YEAR)) + "-"
				+ daf.get("monthLimit") + "-" + daf.get("dayLimit"));
		System.out.println(limit);

		String[] participantAddresses = daf.getString("participantAddress")
				.split("\n");

		// Cxg𐶐
		Event event = new Event(daf.getString("name"),
				daf.getString("outline"), Integer.parseInt(daf.get(
						"requiredDays").toString()), Integer.parseInt(daf.get(
						"requiredHours").toString()), Integer.parseInt(daf.get(
						"requiredMinutes").toString()), limit, daf
						.getString("hostName"), daf.getString("hostAddress"),
				daf.getString("participantAddress"));

		// f[^x[XɃCxgo^
		int eventID = eventManager.getNextID();
		event.setId(eventID);
		System.out.println("eventID=" + event.getId());
		eventManager.register(event);

		// Date^ɕϊ
		List dateList = new ArrayList();
		for (int i = 0; i < Array.getLength(daf.get("candidateDay")); i++) {
			String canDay = daf.get("candidateDay", i).toString();

			SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
			java.util.Date date = sdf.parse(canDay);

			dateList.add(date);
		}

		// o^
		List dayIdList = dayManager.register(eventID, dateList);

		// ⎞Ԃ̃Xg
		int startH = Integer.parseInt(daf.get("candidateBeginningHour")
				.toString());
		int startM = Integer.parseInt(daf.get("candidateBeginningMinute")
				.toString());
		int endH = Integer.parseInt(daf.get("candidateEndingHour").toString());
		int endM = Integer
				.parseInt(daf.get("candidateEndingMinute").toString());
		int nextH, nextM;

		List termList = new ArrayList();
		while (startH != endH || startM != endM) {
			if (startM == 0) {
				nextH = startH;
				nextM = 30;
			} else {
				nextH = startH + 1;
				nextM = 0;
			}
			System.out.println(startH + ":" + startM + "," + nextH + ":"
					+ nextM);
			Term term = new Term(startH, startM, nextH, nextM);
			termList.add(term);
			startH = nextH;
			startM = nextM;
		}

		// ⎞Ԃo^
		termManager.register(termList, dayIdList);

		// 񓚊1OɃ[𑗂
		cal.add(Calendar.DATE, 1);
		cal.set(Calendar.HOUR_OF_DAY, 0);
		cal.set(Calendar.MINUTE, 0);
		System.out.println(cal);
		Timer timer = new Timer();
		System.out.println("** New Thread **");
		timer.scheduleAtFixedRate(new RemindInputThread(eventID),
				cal.getTime(), 1000 * 60 * 60 * 60 * 24);

		// Ƀ[𑗂
		String hostMailTitle = "u" + daf.getString("name")
				+ "v̏҃[Q\҂ɑ܂B";
		String hostMailContent = "Cxg:" + daf.getString("name") + "\n\r"
				+ ":" + daf.getString("hostName") + "\n\r" + "Tv:"
				+ daf.getString("outline") + "\n\r" + "Kv:"
				+ daf.get("requiredDays") + "\n\r" + "Kv:"
				+ daf.get("requiredHours") + "" + daf.get("requiredMinutes")
				+ "\n\r" + "񓚊:" + limit + "\n\r"
				+ "̃AhX犲pj[ʂ֍s܂B\n\r" + FreedomConfig.BASE_URL
				+ "hostMenu.do?eventID=" + eventID;
		FreedomMail.sendMail(daf.getString("hostAddress"), hostMailTitle,
				hostMailContent, false);

		String participantMailTitle = "u" + daf.getString("name")
				+ "v̏҃[󂯎܂B";
		// Q\҂Ƀ[𑗂
		for (int i = 0; i < participantAddresses.length; i++) {
			// Q\҈̃[̓e
			String participantMailAddress = participantAddresses[i].trim();
			if (!participantMailAddress.equals("")) {
				String participantMailContent = "Cxg:"
						+ daf.getString("name") + "\n\r" + ":"
						+ daf.getString("hostName") + "\n\r" + "Tv:"
						+ daf.getString("outline") + "\n\r" + "Kv:"
						+ daf.get("requiredDays") + "\n\r" + "Kv:"
						+ daf.get("requiredHours") + ""
						+ daf.get("requiredMinutes") + "\n\r" + "񓚊:"
						+ limit + "\n\r"
						+ "̃AhXQ\җpj[ʂ֍sė\LĂB\n\r"
						+ FreedomConfig.BASE_URL + "scheduleList.do?eventID="
						+ eventID + "&address=" + participantMailAddress;
				FreedomMail.sendMail(participantAddresses[i].trim(),
						participantMailTitle, participantMailContent, false);
				participantManager.registParticipant(participantMailAddress,
						eventID);
				scheduleManager.registSchedule(participantMailAddress, eventID);
			}
			scheduleManager.registSchedule(participantMailAddress, eventID);
		}

		String url = FreedomConfig.BASE_URL + "hostMenu.do?eventID=" + eventID;
		request.setAttribute("url", url);
		return mapping.findForward("success");
	}
}
