package freedom.struts.participant.action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.TermManager;

public class ConfirmAttendanceAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(form.get("eventID").toString());
		int userID = Integer.parseInt(form.get("userID").toString());

		String isParticipate = form.getString("isParticipate");

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		ParticipantManager participantManager = new ParticipantManager();
		Participant participant = participantManager.getParticipant(userID);

		DayManager dayManager = new DayManager();
		List definedDayList = dayManager.getDefinedDayList(eventID);

		TermManager termManager = new TermManager();
		Term definedTerm = termManager.getDefinedTerm(definedDayList);

		if (form.getString("name") == null || form.getString("name").equals("")) {
			form.set("name", participant.getName());
		} else {
			participant.setName(form.getString("name"));
		}

		request.setAttribute("event", event);
		request.setAttribute("participant", participant);
		request.setAttribute("definedDayList", definedDayList);
		request.setAttribute("definedTerm", definedTerm);
		request.setAttribute("isParticipate", isParticipate);
		return mapping.findForward("success");
	}
}
