package freedom.struts.participant.action;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Schedule;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class ConfirmScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());
		int userID = Integer.parseInt(request.getSession().getAttribute(
				"userID").toString());
		String mailAddress = request.getSession().getAttribute("mailAddress")
				.toString();

		EventManager eventManager = new EventManager();
		ParticipantManager participantManager = new ParticipantManager();
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();
		ScheduleManager scheduleManager = new ScheduleManager();

		Event event = eventManager.getEvent(eventID);
		List participantiList = participantManager.getParticipantList(eventID);
		List dayList = dayManager.getDayList(eventID);
		List termList = termManager.getTermList(((Day) dayList.get(0)).getID());
		List sList = scheduleManager.getScheduleList(eventID, mailAddress);

		String[] convinience = form.getStrings("convinienceList");
		List scheduleList = new ArrayList();
		for (int i = 0; i < convinience.length; i++) {
			String[] conv = convinience[i].split(",");
			for (Iterator ite = sList.iterator(); ite.hasNext();) {
				Schedule schedule = (Schedule) ite.next();
				if (Integer.parseInt(conv[0]) == schedule.getTermID()) {
					schedule.setConvinience(Integer.parseInt(conv[1]));
					scheduleList.add(schedule);
				}
			}
		}

		request.setAttribute("event", event);
		request.setAttribute("participantList", participantiList);
		request.setAttribute("dayList", dayList);
		request.setAttribute("termList", termList);
		request.setAttribute("scheduleList", scheduleList);
		request.setAttribute("eventID", new Integer(eventID));
		request.setAttribute("userID", new Integer(userID));
		if (form.getString("name").equals("") || form.get("name") == null) {
			request.setAttribute("isDefinedDayExist", "false");
			return mapping.findForward("fail");
		} else {
			return mapping.findForward("success");
		}
	}
}
