package freedom.struts.participant.action;

import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.TermManager;

public class InputAttendanceAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		int eventID;
		int userID;

		EventManager eventManager = new EventManager();
		ParticipantManager participantManager = new ParticipantManager();
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();

		if (request.getParameter("eventID") != null) {
			eventID = Integer.parseInt(request.getParameter("eventID"));
		} else if (request.getSession().getAttribute("eventID") != null) {
			eventID = Integer.parseInt(request.getSession().getAttribute(
					"eventID").toString());
		} else {
			eventID = -1;
		}

		if (request.getParameter("userID") != null) {
			userID = Integer.parseInt(request.getParameter("userID"));
		} else if (request.getSession().getAttribute("mailAddress") != null) {
			String mailAddress = request.getSession().getAttribute(
					"mailAddress").toString();
			System.out.println("madd:" + mailAddress);
			Participant participant = participantManager.getParticipant(
					mailAddress, eventID);
			userID = participant.getID();
		} else {
			userID = -1;
		}

		Event event = eventManager.getEvent(eventID);
		Participant participant = participantManager.getParticipant(userID);
		List definedDayList = dayManager.getDefinedDayList(eventID);
		Term definedTerm = termManager.getDefinedTerm(definedDayList);

		request.setAttribute("event", event);
		request.setAttribute("participant", participant);
		request.setAttribute("definedDayList", definedDayList);
		request.setAttribute("definedTerm", definedTerm);
		return mapping.findForward("success");
	}
}
