package freedom.struts.participant.action;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class InputScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());
		int userID = Integer.parseInt(request.getSession().getAttribute(
				"userID").toString());
		String mailAddress = request.getSession().getAttribute("mailAddress")
				.toString();

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		ParticipantManager participantManager = new ParticipantManager();
		List participantiList = participantManager.getParticipantList(eventID);

		DayManager dayManager = new DayManager();
		List dayList = dayManager.getDayList(eventID);
		for (int i = 0; i < dayList.size(); i++) {
			Day day = (Day) dayList.get(i);
			Date date = day.getDate();
			Calendar cal = Calendar.getInstance();
			cal.setTime(date);
			String dow = null;
			switch (cal.get(Calendar.DAY_OF_WEEK)) {
				case Calendar.SUNDAY :
					dow = "()";
					break;
				case Calendar.MONDAY :
					dow = "()";
					break;
				case Calendar.TUESDAY :
					dow = "()";
					break;
				case Calendar.WEDNESDAY :
					dow = "()";
					break;
				case Calendar.THURSDAY :
					dow = "()";
					break;
				case Calendar.FRIDAY :
					dow = "()";
					break;
				case Calendar.SATURDAY :
					dow = "(y)";
					break;
			}
			day.setDayOfWeek(dow);
			dayList.set(i, day);
		}

		TermManager termManager = new TermManager();
		List termList = termManager.getTermList(((Day) dayList.get(0)).getID());

		ScheduleManager scheduleManager = new ScheduleManager();
		List scheduleList = scheduleManager.getScheduleList(eventID);

		Participant participant = participantManager.getParticipant(
				mailAddress, eventID);

		String name = "";
		if (participant.getName() != null) {
			name = participant.getName();
		}

		request.setAttribute("event", event);
		request.setAttribute("participantList", participantiList);
		request.setAttribute("dayList", dayList);
		request.setAttribute("termList", termList);
		request.setAttribute("scheduleList", scheduleList);

		request.setAttribute("eventID", new Integer(eventID));
		request.setAttribute("userID", new Integer(userID));
		request.getSession().setAttribute("name", name);

		return mapping.findForward("success");
	}
}
