package freedom.struts.participant.action;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.TermManager;

public class RegistAttendanceAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(form.get("eventID").toString());
		int userID = Integer.parseInt(form.get("userID").toString());

		String isParticipate = form.getString("isParticipate");

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);
		request.setAttribute("event", event);

		if (!event.getIsCancel()) {
			ParticipantManager participantManager = new ParticipantManager();
			Participant participant = participantManager.getParticipant(userID);

			DayManager dayManager = new DayManager();
			List definedDayList = dayManager.getDefinedDayList(eventID);

			TermManager termManager = new TermManager();
			Term definedTerm = termManager.getDefinedTerm(definedDayList);

			if (isParticipate.equals("Q")) {
				participantManager.registParticipation(participant.getID(),
						true, form.getString("name"));
			} else {
				participantManager.registParticipation(participant.getID(),
						false, form.getString("name"));
			}

			String participantName;
			if (participant.getName() != null) {
				participantName = participant.getName();
			} else {
				participantName = form.getString("name");
			}
			String participantMailAddress = request.getSession().getAttribute(
					"mailAddress").toString();

			// Q\҂̐l߂
			List participantList = participantManager
					.getParticipantList(eventID);
			List participateList = new ArrayList();
			int participantNumber = 0;
			for (Iterator ite = participantList.iterator(); ite.hasNext();) {
				Participant p = (Participant) ite.next();
				if (p.getIsParticipate() == true) {
					participateList.add(p);
					participantNumber++;
				}
			}

			// Ƀ[𑗐M
			String hostMailTitle = participantName + "񂪏oXV܂";
			StringBuffer hostMailContent = new StringBuffer(participantName
					+ "񂪏oXV܂B\n\r" + "݂̏oȎ҂́A\n\r");
			for (Iterator ite = participateList.iterator(); ite.hasNext();) {
				Participant participant2 = (Participant) ite.next();
				hostMailContent.append(participant2.getName() + " \n\r");
			}
			hostMailContent.append("" + participantNumber + "lłB\n\r"
					+ "j[ʂŁAo󋵂mFł܂B\n\r" + FreedomConfig.BASE_URL
					+ "hostMenu.do?eventID=" + eventID);
			FreedomMail.sendMail(event.getHostAddress(), hostMailTitle,
					hostMailContent.toString(), false);

			// Q\҂ɍT[𑗐M
			String participantMailTitle = "o̓o^܂";
			StringBuffer participantMailContent = new StringBuffer(
					"o̓o^܂B\n\r" + "݂̏oȎ҂́A\n\r");
			for (Iterator ite = participateList.iterator(); ite.hasNext();) {
				Participant participant2 = (Participant) ite.next();
				participantMailContent.append(participant2.getName()
						+ " \n\r");
			}
			participantMailContent.append("" + participantNumber + "lłB\n\r"
					+ "\ꗗʂȍ󋵂mFł܂B\n\r" + FreedomConfig.BASE_URL
					+ "scheduleList.do?eventID=" + eventID + "&address="
					+ participant.getMailaddress());
			FreedomMail.sendMail(participantMailAddress, participantMailTitle,
					participantMailContent.toString(), false);

			request.setAttribute("event", event);
			request.setAttribute("participant", participant);
			request.setAttribute("definedDayList", definedDayList);
			request.setAttribute("definedTerm", definedTerm);
			request.setAttribute("isParticipate", isParticipate);
			return mapping.findForward("success");
		} else {
			return mapping.findForward("fail");
		}
	}
}
