package freedom.struts.schedule.action;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;
import org.apache.struts.util.LabelValueBean;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Term;
import freedom.server.model.TermPriority;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantComparator;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.PriorityComparator;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class DecideScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		// int eventID = Integer.parseInt(form.get("eventID").toString());
		int eventID = Integer.parseInt(request.getSession().getAttribute(
				"eventID").toString());

		form.set("definedDay", null);

		if (request.getAttribute("isDefinedDayExist") == null) {
			request.setAttribute("isDefinedDayExist", "true");
		}

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		int[] vipID = new int[Array.getLength(form.get("priority"))];
		for (int i = 0; i < Array.getLength(form.get("priority")); i++) {
			vipID[i] = Integer.parseInt((form.get("priority", i).toString()));
		}

		ParticipantManager participantManager = new ParticipantManager();
		List participantiList = participantManager.getParticipantList(eventID);

		DayManager dayManager = new DayManager();
		List dayList = dayManager.getDayList(eventID);

		TermManager termManager = new TermManager();
		List termList = termManager.getTermList(((Day) dayList.get(0)).getID());

		List priorityTermList = termManager.getTermList(eventID, vipID);
		Collections.sort(priorityTermList, new ParticipantComparator());

		// ZNgtH[p̌̃Xg
		List scheduleTimeList = new ArrayList();
		for (Iterator ite = termList.iterator(); ite.hasNext();) {
			Term term = (Term) ite.next();
			String startTime = String.valueOf(term.getStartHour());
			LabelValueBean startLVB = new LabelValueBean(startTime, startTime);
			String endTime = String.valueOf(term.getEndHour());
			LabelValueBean endLVB = new LabelValueBean(endTime, endTime);
			if (!scheduleTimeList.contains(startLVB)) {
				scheduleTimeList.add(startLVB);
			}
			if (!scheduleTimeList.contains(endLVB)) {
				scheduleTimeList.add(endLVB);
			}
		}

		List priorityList = new ArrayList();
		for (Iterator ite = priorityTermList.iterator(); ite.hasNext();) {
			Term term = (Term) ite.next();
			TermPriority priority = new TermPriority(term
					.getParticipantNumber(), term.getVipNumber(), term
					.getPriority());
			if (!isConteinPriority(priorityList, term.getPriority())) {
				priorityList.add(priority);
			}
		}
		Collections.sort(priorityList, new PriorityComparator());

		ScheduleManager scheduleManager = new ScheduleManager();
		List calendarList = scheduleManager.getCalendarList(dayList);

		request.setAttribute("calendarList", calendarList);
		request.setAttribute("event", event);
		request.setAttribute("participantList", participantiList);
		request.setAttribute("priorityTermList", priorityTermList);
		request.setAttribute("priorityList", priorityList);
		request.setAttribute("dayList", dayList);
		request.setAttribute("termList", termList);
		request.setAttribute("priority", form.get("priority"));
		request.setAttribute("subjoinder", form.get("subjoinder"));
		request.setAttribute("scheduleTimeList", scheduleTimeList);
		return mapping.findForward("success");
	}
	private boolean isConteinPriority(List priorityList, int priority) {
		for (Iterator ite2 = priorityList.iterator(); ite2.hasNext();) {
			TermPriority termPriority = (TermPriority) ite2.next();
			if (termPriority.getPriority() == priority) {
				return true;
			}
		}
		return false;
	}
}
