package freedom.struts.schedule.action;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.mail.FreedomMail;
import freedom.server.FreedomConfig;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.TermManager;

public class FinishDecideScheduleAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		int eventID = Integer.parseInt(form.get("eventID").toString());

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);
		request.setAttribute("event", event);

		if (!event.getIsCancel()) {
			List definedDayList = new ArrayList();
			DayManager dayManager = new DayManager();

			for (int i = 0; i < Array.getLength(form.get("definedDay")); i++) {
				String date = "2006/" + form.get("definedDay", i).toString();
				definedDayList.add(dayManager.getDefinedDayList(eventID, date)
						.get(0));
			}
			dayManager.registerDefinedSchedule(definedDayList);

			eventManager.registSubjoinder(eventID, form.get("subjoinder")
					.toString());

			TermManager termManager = new TermManager();
			termManager.registDefine(definedDayList, Integer.parseInt(form.get(
					"beginningHour").toString()), Integer.parseInt(form.get(
					"beginningMinute").toString()), eventID);

			ParticipantManager participantManager = new ParticipantManager();
			List participantList = participantManager
					.getParticipantList(eventID);

			for (Iterator ite = participantList.iterator(); ite.hasNext();) {
				Participant participant = (Participant) ite.next();
				StringBuffer mail = new StringBuffer("CxgF");
				mail.append(event.getName() + "\n");
				mail.append("F");
				for (int i = 0; i < Array.getLength(form.get("definedDay")); i++) {
					mail.append(form.get("definedDay", i).toString() + "@");
				}
				mail.append("\n\r");
				mail
						.append("JnԁF" + form.get("beginningHour").toString()
								+ ":" + form.get("beginningMinute").toString()
								+ "\n\r");
				mail.append("vԁF" + event.getRequiredHours() + "\n\r");
				mail.append("ǋLF" + form.get("subjoinder").toString()
						+ "\n\r");
				mail.append("\ꗗʂo̓o^sĂD\n\r");
				mail.append(FreedomConfig.BASE_URL + "scheduleList.do?eventID="
						+ eventID + "&address=" + participant.getMailaddress());
				FreedomMail.sendMail(participant.getMailaddress(),
						"Cxg̓܂܂", mail.toString(), false);
			}

			request.setAttribute("definedDay", definedDayList);
			request.setAttribute("beginningHour", form.get("beginningHour")
					.toString());
			request.setAttribute("beginningMinute", form.get("beginningMinute")
					.toString());
			request.setAttribute("subjoinder", form.get("subjoinder")
					.toString());
			return mapping.findForward("success");
		} else {
			return mapping.findForward("fail");
		}
	}
}
