package freedom.struts.schedule.action;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

import freedom.server.model.Day;
import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class HostMenuAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		DynaActionForm form = (DynaActionForm) actionForm;
		form.set("priority", new Integer[0]);

		EventManager eventManager = new EventManager();
		ParticipantManager participantManager = new ParticipantManager();
		DayManager dayManager = new DayManager();
		TermManager termManager = new TermManager();
		ScheduleManager scheduleManager = new ScheduleManager();

		int eventID;
		if (request.getParameter("eventID") != null) {
			eventID = Integer.parseInt(request.getParameter("eventID"));
			System.out.println("aruyo" + eventID);
		} else {
			eventID = Integer.parseInt(form.get("eventID").toString());
			System.out.println("naiyo" + eventID);
		}

		Event event = eventManager.getEvent(eventID);
		List participantList = participantManager.getParticipantList(eventID);
		List dayList = dayManager.getDayList(eventID);
		List termList = termManager.getTermList(((Day) dayList.get(0)).getID());
		List scheduleList = scheduleManager.getScheduleList(eventID);

		// Q\҂̐l߂
		int participantNumber = 0;
		for (Iterator ite = participantList.iterator(); ite.hasNext();) {
			Participant participant = (Participant) ite.next();
			if (participant.getIsParticipate() == true) {
				participantNumber++;
			}
		}

		List definedDayList = dayManager.getDefinedDayList(eventID);
		Term definedTerm = termManager.getDefinedTerm(definedDayList);

		boolean isDefined = false;
		if (definedDayList.size() > 0) {
			isDefined = true;
		}

		request.setAttribute("event", event);
		request.setAttribute("participantList", participantList);
		request.setAttribute("dayList", dayList);
		request.setAttribute("termList", termList);
		request.setAttribute("scheduleList", scheduleList);
		request.setAttribute("participantNumber", String
				.valueOf(participantNumber));
		request.setAttribute("definedDayList", definedDayList);
		request.setAttribute("definedTerm", definedTerm);
		request.setAttribute("isDefined", new Boolean(isDefined));

		request.getSession().setAttribute("eventID", new Integer(eventID));
		return mapping.findForward("success");
	}
}
