package freedom.struts.schedule.action;

import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import freedom.server.model.Event;
import freedom.server.model.Participant;
import freedom.server.model.Term;
import freedom.server.transaction.DayManager;
import freedom.server.transaction.EventManager;
import freedom.server.transaction.ParticipantManager;
import freedom.server.transaction.ScheduleManager;
import freedom.server.transaction.TermManager;

public class ViewParticipationAction extends Action {
	public ActionForward execute(ActionMapping mapping, ActionForm actionForm,
			HttpServletRequest request, HttpServletResponse response)
			throws Exception {
		int eventID = Integer.parseInt(request.getParameter("eventID"));

		EventManager eventManager = new EventManager();
		Event event = eventManager.getEvent(eventID);

		ParticipantManager participantManager = new ParticipantManager();
		List participantList = participantManager.getParticipantList(eventID);

		ScheduleManager scheduleManager = new ScheduleManager();
		List scheduleList = scheduleManager.getScheduleList(eventID);

		DayManager dayManager = new DayManager();
		List definedDayList = dayManager.getDefinedDayList(eventID);

		TermManager termManager = new TermManager();
		Term definedTerm = termManager.getDefinedTerm(definedDayList);

		int participantNumber = 0;
		for (Iterator ite = participantList.iterator(); ite.hasNext();) {
			Participant participant = (Participant) ite.next();
			if (participant.getIsParticipate() == true) {
				participantNumber++;
			}
		}
		
		

		request.setAttribute("event", event);
		request.setAttribute("participantList", participantList);
		request.setAttribute("participantNumber", String
				.valueOf(participantNumber));
		request.setAttribute("scheduleList", scheduleList);
		request.setAttribute("definedDayList", definedDayList);
		request.setAttribute("definedTerm", definedTerm);
		return mapping.findForward("success");
	}
}
